"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var postgres_1 = __importDefault(require("postgres"));
var fs = __importStar(require("fs"));
var pglo = __importStar(require(".."));
var chai_1 = require("chai");
var crypto = __importStar(require("crypto"));
var connectionURL = process.env.POSTGRES_URL || 'postgres://nodetest:nodetest@localhost/nodetest';
var testFile = __dirname + '/../../assets/postgresjs.svg';
var testOutFile = __dirname + '/../../assets/out.svg';
var testFileSize = fs.statSync(testFile).size;
var testBuf = new Buffer('0123456789ABCDEF', 'hex');
var sha256_hex = function (filename) {
    var sum = crypto.createHash('sha256');
    var s = fs.createReadStream(filename);
    s.on('data', function (data) { return sum.update(data); });
    return new Promise(function (resolve, reject) {
        s.on('error', reject);
        s.on('end', function () { return resolve(sum.digest('hex')); });
    });
};
describe('LargeObjectManager', function () {
    var sql;
    var oid;
    beforeAll(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            sql = postgres_1["default"](connectionURL);
            return [2 /*return*/];
        });
    }); });
    afterAll(function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sql.end()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test('create', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sql.begin(function (trx) { return __awaiter(void 0, void 0, void 0, function () {
                        var manager;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    manager = new pglo.LargeObjectManager(trx);
                                    return [4 /*yield*/, manager.createAsync()];
                                case 1:
                                    oid = _a.sent();
                                    chai_1.expect(oid).not.equal(0);
                                    console.log('creating a new Large Object with oid: ', oid);
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test('write', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sql.begin(function (trx) { return __awaiter(void 0, void 0, void 0, function () {
                        var manager, obj;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    manager = new pglo.LargeObjectManager(trx);
                                    return [4 /*yield*/, manager.openAsync(oid, pglo.LargeObjectManager.WRITE)];
                                case 1:
                                    obj = _a.sent();
                                    return [4 /*yield*/, obj.writeAsync(testBuf)];
                                case 2:
                                    _a.sent();
                                    return [4 /*yield*/, obj.closeAsync()];
                                case 3:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test('read first 2 byte', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sql.begin(function (trx) { return __awaiter(void 0, void 0, void 0, function () {
                        var manager, obj, buf;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    manager = new pglo.LargeObjectManager(trx);
                                    return [4 /*yield*/, manager.openAsync(oid, pglo.LargeObjectManager.READ)];
                                case 1:
                                    obj = _a.sent();
                                    return [4 /*yield*/, obj.readAsync(2)];
                                case 2:
                                    buf = _a.sent();
                                    return [4 /*yield*/, obj.closeAsync()];
                                case 3:
                                    _a.sent();
                                    chai_1.expect(buf).have.length(2);
                                    chai_1.expect(buf[0]).equal(testBuf[0]);
                                    chai_1.expect(buf[1]).equal(testBuf[1]);
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test('tell', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sql.begin(function (trx) { return __awaiter(void 0, void 0, void 0, function () {
                        var manager, obj, position;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    manager = new pglo.LargeObjectManager(trx);
                                    return [4 /*yield*/, manager.openAsync(oid, pglo.LargeObjectManager.READ)];
                                case 1:
                                    obj = _a.sent();
                                    return [4 /*yield*/, obj.readAsync(2)];
                                case 2:
                                    _a.sent();
                                    return [4 /*yield*/, obj.tellAsync()];
                                case 3:
                                    position = _a.sent();
                                    return [4 /*yield*/, obj.closeAsync()];
                                case 4:
                                    _a.sent();
                                    chai_1.expect(position).equal(2);
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test('size', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sql.begin(function (trx) { return __awaiter(void 0, void 0, void 0, function () {
                        var manager, obj, size;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    manager = new pglo.LargeObjectManager(trx);
                                    return [4 /*yield*/, manager.openAsync(oid, pglo.LargeObjectManager.READ)];
                                case 1:
                                    obj = _a.sent();
                                    return [4 /*yield*/, obj.sizeAsync()];
                                case 2:
                                    size = _a.sent();
                                    return [4 /*yield*/, obj.closeAsync()];
                                case 3:
                                    _a.sent();
                                    chai_1.expect(size).equal(testBuf.length);
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test('tell after size', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sql.begin(function (trx) { return __awaiter(void 0, void 0, void 0, function () {
                        var manager, obj, position;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    manager = new pglo.LargeObjectManager(trx);
                                    return [4 /*yield*/, manager.openAsync(oid, pglo.LargeObjectManager.READ)];
                                case 1:
                                    obj = _a.sent();
                                    return [4 /*yield*/, obj.readAsync(2)];
                                case 2:
                                    _a.sent();
                                    return [4 /*yield*/, obj.sizeAsync()];
                                case 3:
                                    _a.sent();
                                    return [4 /*yield*/, obj.tellAsync()];
                                case 4:
                                    position = _a.sent();
                                    return [4 /*yield*/, obj.closeAsync()];
                                case 5:
                                    _a.sent();
                                    chai_1.expect(position).equal(2, 'calling size() should not change the position');
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test('read with buffer size larger than size', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sql.begin(function (trx) { return __awaiter(void 0, void 0, void 0, function () {
                        var manager, obj, buf, i;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    manager = new pglo.LargeObjectManager(trx);
                                    return [4 /*yield*/, manager.openAsync(oid, pglo.LargeObjectManager.READ)];
                                case 1:
                                    obj = _a.sent();
                                    return [4 /*yield*/, obj.readAsync(2)];
                                case 2:
                                    _a.sent();
                                    return [4 /*yield*/, obj.readAsync(100)];
                                case 3:
                                    buf = _a.sent();
                                    return [4 /*yield*/, obj.closeAsync()];
                                case 4:
                                    _a.sent();
                                    chai_1.expect(buf).have.length(6);
                                    for (i = 0; i < 6; i++) {
                                        chai_1.expect(buf[i]).equal(testBuf[i + 2]);
                                    }
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test('seek', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sql.begin(function (trx) { return __awaiter(void 0, void 0, void 0, function () {
                        var manager, obj, buf;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    manager = new pglo.LargeObjectManager(trx);
                                    return [4 /*yield*/, manager.openAsync(oid, pglo.LargeObjectManager.READ)];
                                case 1:
                                    obj = _a.sent();
                                    return [4 /*yield*/, obj.readAsync(2)];
                                case 2:
                                    _a.sent();
                                    return [4 /*yield*/, obj.seekAsync(-2, pglo.LargeObject.SEEK_END)];
                                case 3:
                                    _a.sent();
                                    return [4 /*yield*/, obj.readAsync(100)];
                                case 4:
                                    buf = _a.sent();
                                    return [4 /*yield*/, obj.closeAsync()];
                                case 5:
                                    _a.sent();
                                    chai_1.expect(buf).have.length(2);
                                    chai_1.expect(buf[0]).equal(testBuf[6]);
                                    chai_1.expect(buf[1]).equal(testBuf[7]);
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test('unlink', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sql.begin(function (trx) { return __awaiter(void 0, void 0, void 0, function () {
                        var manager;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0:
                                    manager = new pglo.LargeObjectManager(trx);
                                    console.log('unlinking the Large Object with oid: ', oid);
                                    return [4 /*yield*/, manager.unlinkAsync(oid)];
                                case 1:
                                    _a.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test('write stream', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sql.begin(function (trx) { return __awaiter(void 0, void 0, void 0, function () {
                        var manager, _a, _oid, stream, fileStream;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    manager = new pglo.LargeObjectManager(trx);
                                    return [4 /*yield*/, manager.createAndWritableStreamAsync()];
                                case 1:
                                    _a = _b.sent(), _oid = _a[0], stream = _a[1];
                                    oid = _oid;
                                    console.log('creating a new Large Object with oid: ', oid);
                                    fileStream = fs.createReadStream(testFile);
                                    fileStream.pipe(stream);
                                    return [4 /*yield*/, new Promise(function (resolve, reject) {
                                            stream.on('error', reject);
                                            stream.on('finish', resolve);
                                        })];
                                case 2:
                                    _b.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    test('read stream', function () { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, sql.begin(function (trx) { return __awaiter(void 0, void 0, void 0, function () {
                        var manager, origHash, _a, size, stream, fileStream, outHash;
                        return __generator(this, function (_b) {
                            switch (_b.label) {
                                case 0:
                                    manager = new pglo.LargeObjectManager(trx);
                                    return [4 /*yield*/, sha256_hex(testFile)];
                                case 1:
                                    origHash = _b.sent();
                                    return [4 /*yield*/, manager.openAndReadableStreamAsync(oid)];
                                case 2:
                                    _a = _b.sent(), size = _a[0], stream = _a[1];
                                    chai_1.expect(size).equal(testFileSize);
                                    fileStream = fs.createWriteStream(testOutFile);
                                    stream.pipe(fileStream);
                                    return [4 /*yield*/, new Promise(function (resolve, reject) {
                                            stream.on('end', resolve);
                                            stream.on('error', reject);
                                        })];
                                case 3:
                                    _b.sent();
                                    return [4 /*yield*/, sha256_hex(testOutFile)];
                                case 4:
                                    outHash = _b.sent();
                                    chai_1.expect(outHash).equal(origHash);
                                    console.log('unlinking the Large Object with oid: ', oid);
                                    return [4 /*yield*/, manager.unlinkAsync(oid)];
                                case 5:
                                    _b.sent();
                                    return [2 /*return*/];
                            }
                        });
                    }); })];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
});
